using BlacksmithWorkshopContracts.BindingModels;
using BlacksmithWorkshopContracts.SearchModels;
using BlacksmithWorkshopContracts.StorageContracts;
using BlacksmithWorkshopContracts.ViewModels;
using BlacksmithWorkshopDatabaseImplement.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace BlacksmithWorkshopDatabaseImplement.Implements
{
	public class MessageInfoStorage : IMessageInfoStorage
	{
		public List<MessageInfoViewModel> GetFullList()
		{
			using var context = new BlacksmithWorkshopDatabase();
			return context.MessageInfos
					.Select(x => x.GetViewModel)
					.ToList();
		}
		public List<MessageInfoViewModel> GetFilteredList(MessageInfoSearchModel model)
		{
			using var context = new BlacksmithWorkshopDatabase();
			return context.MessageInfos
					.Where(x => x.ClientId.HasValue && x.ClientId == model.ClientId)
					.Select(x => x.GetViewModel)
					.ToList();
		}
		public MessageInfoViewModel? GetElement(MessageInfoSearchModel model)
		{
			using var context = new BlacksmithWorkshopDatabase();
			return context.MessageInfos
					.FirstOrDefault(x => !string.IsNullOrEmpty(x.MessageId) && x.MessageId == model.MessageId)
					?.GetViewModel;
		}
		public MessageInfoViewModel? Insert(MessageInfoBindingModel model)
		{
			using var context = new BlacksmithWorkshopDatabase();
			var newMessage = MessageInfo.Create(model);
			if (newMessage == null)
			{
				return null;
			}
			context.MessageInfos.Add(newMessage);
			context.SaveChanges();
			return newMessage.GetViewModel;
		}
	}
}
